/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.supinfo.spitfireboard.services;

import com.supinfo.spitfireboard.dao.PostDao;
import com.supinfo.spitfireboard.dao.UserDao;
import com.supinfo.spitfireboard.entities.Post;
import com.supinfo.spitfireboard.entities.User;
import com.supinfo.spitfireboard.helpers.Password;
import java.util.Date;
import java.util.List;
import javax.ejb.EJB;
import javax.ejb.Stateless;

/**
 *
 * @author Fabien LOISON
 */
@Stateless
public class UserService {
    
    @EJB
    private UserDao userDao;
    
    @EJB
    private PostDao postDao;
    
    public User getUser(Long id) {
        return userDao.getById(id);
    }
    
    public List<Post> getUserLatestPost(Long id) {
        return postDao.getPostsByUserId(id);
    }
    
    public User authenticate(String userName, String password) {
        try {
            User user = (User) userDao.getByUserName(userName);
            if (user instanceof User) {
                if (user.getPassword().equals(Password.hash(password))) {
                    return user;
                }
            }
        } catch (Exception e) {
            return null;
        }
        return null;
    }
    
    public Boolean userExists(String userName) {
        User user = userDao.getByUserName(userName);
        return (user != null);
    }
    
    public void newUser(String userName, String email, String password) {
        userDao.insertUser(userName, email, password,
                "http://pix.toile-libre.org/upload/original/1395844036.png",
                2, new Date());
    }
    
    public Long changeRole(Long userId, Integer userRole) {
        User user = this.getUser(userId);
        user.setUserRole(userRole);
        userDao.persistUser(user);
        return userId;
    }
    
    public Long userEdit(Long userId, String username, String email, String avatar) {
        User user = this.getUser(userId);
        user.setUserName(username);
        user.setEmail(email);
        user.setAvatar(avatar);
        userDao.persistUser(user);
        return userId;
    }
    
    public Long changePassword(Long userId, String password) {
        User user = this.getUser(userId);
        user.setPassword(password);
        userDao.persistUser(user);
        return userId;
    }
    
    public void deleteUser(Long id) {
        userDao.delete(id);
    }
    
}
